﻿Class Window1 
    Dim tc As TaxControls.CTaxControl

    Private Sub Window1_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Dim t As TaxControls.Tax

        tc = New TaxControls.CTaxControl()
        tc.DataFilename = FindTaxFile()
        cmbStates.Items.Clear()
        For Each t In tc.Taxes
            If t.TaxType = "S" Then
                cmbStates.Items.Add(t.Name)
            End If
            If cmbStates.Items.Count > 1 Then
                cmbStates.SelectedIndex = 1
            End If
        Next
        txtEarnings.Focus()
    End Sub

    Private Sub cmbStates_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)
        Dim t As TaxControls.Tax
        Dim state As String = cmbStates.SelectedItem.ToString()

        cmbLocal.Items.Clear()
        If state <> "" Then
            cmbLocal.Items.Add("<none>")
            For Each t In tc.Taxes
                If t.TaxType = "L" And t.Name.StartsWith(state) Then
                    cmbLocal.Items.Add(t.Name)
                End If
            Next
            cmbLocal.SelectedIndex = 1
        End If
    End Sub

    Private Sub btnCompute_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        tc.Earnings = Convert.ToDouble(txtEarnings.Text)
        tc.FilingStatus = GetFilingStatus()
        tc.Exemptions = Convert.ToInt32(txtExemptions.Text)
        Try
            tc.SelectedTax = "fit"
            txtFederal.Text = String.Format("{0:0.00}", tc.TaxAmount())
            tc.SelectedTax = "fica"
            txtFICA.Text = String.Format("{0:0.00}", tc.TaxAmount())
            txtState.Text = "0.00"
            txtLocal.Text = "0.00"
            If (cmbStates.SelectedIndex >= 0) Then
                tc.SelectedTax = cmbStates.SelectedValue.ToString()
                txtState.Text = String.Format("{0:0.00}", tc.TaxAmount())
            End If
            If (cmbLocal.SelectedIndex > 0) Then
                tc.SelectedTax = cmbLocal.SelectedValue.ToString()
                txtLocal.Text = String.Format("{0:0.00}", tc.TaxAmount())
            End If
        Catch er As TaxControlException
            MessageBox.Show(er.Message)
        End Try
    End Sub

    Private Function GetFilingStatus() As TaxControls.FilingStatus
        Dim i As Integer = cmbFilingStatus.SelectedIndex

        Select i
            Case 0
                GetFilingStatus = TaxControls.FilingStatus.FilingSingle
            Case 1
                GetFilingStatus = TaxControls.FilingStatus.FilingHeadOfHousehold
            Case 2
                GetFilingStatus = TaxControls.FilingStatus.FilingWidow
            Case 3
                GetFilingStatus = TaxControls.FilingStatus.FilingMarried
            Case 4
                GetFilingStatus = TaxControls.FilingStatus.FilingSeparate
            Case 5
                GetFilingStatus = TaxControls.FilingStatus.FilingBothEmployed
            Case Else
                GetFilingStatus = TaxControls.FilingStatus.FilingSingle
        End Select
    End Function

    ' searches for file with "*.tax" extension in current and ancestor directories
    Private Function FindTaxFile() As String
        Dim di As New IO.DirectoryInfo(".")
        Dim path As String = ""
        Dim fi As IO.FileInfo()
        Do Until (di Is Nothing)
            fi = di.GetFiles("*.tax")
            If fi.Length > 0 Then
                FindTaxFile = path + fi(0).ToString()
                Exit Function
            End If
            di = di.Parent
            path += "../"
        Loop
        MsgBox("Could not find a tax table file (*.tax).")
        Throw New Exception("Tax table not found")
    End Function
End Class
